package com.fladsrud.databasecreator;
import java.sql.*;

public class DatabaseConnection {
  private Connection connection;
  private int numberOfColumns;
  private java.util.Vector v_ret = new java.util.Vector();

    public DatabaseConnection(String db_file_name_prefix, String pw, String user, String dbURL, String forname) throws Exception{    // note more general exception

        Class.forName(forname);
        connection = DriverManager.getConnection(dbURL+db_file_name_prefix,   // filenames
                                           user,                    // username
                                           pw);                     // password
    }

    public void shutdown() throws SQLException {
        connection.close();
    }

    public String[][] getQueryOutput(){
      String ret[][];
      if (v_ret.isEmpty()){
        return null;
      }
      int size = v_ret.size();
      ret = new String[size][numberOfColumns];
      for(int i=0; i < size; i++){
        String tmpret[] = (String[])v_ret.elementAt(i);
        for(int t=0; t < tmpret.length; t++){
            ret[i][t]=(String)tmpret[t];
        }
      }
      return ret;
    }
    public synchronized void query(String expression) throws SQLException {
        v_ret.removeAllElements();
        Statement st = null;
        ResultSet rs = null;
        numberOfColumns=0;
        try{
        st = connection.createStatement();
        rs = st.executeQuery(expression);
        if(expression.substring(0,"SELECT".length()).equalsIgnoreCase("SELECT")){
          ResultSetMetaData rsmd = rs.getMetaData();

          numberOfColumns = rsmd.getColumnCount();
          System.out.println("numberOfColumns="+numberOfColumns);
          String collumns[] = new String[numberOfColumns];
          for (int x= 1; x<= numberOfColumns; x++){
            collumns[x-1] = rsmd.getColumnName(x);
            System.out.print(collumns[x-1]);
          }

          System.out.println();
            v_ret.addElement(collumns);
          //boolean b = rsmd.isSearchable(1);

          if(rs.next()){

          do {
            String tmp[] = new String[numberOfColumns];
            for (int c=1; c<=numberOfColumns; c++){
            String value = rs.getString(c);
            tmp[c-1] = value;
            System.out.print(value+"    ");
            }
            System.out.println();
            v_ret.addElement(tmp);
          }while(rs.next());
          }
        }
        }catch (SQLException sqle){
          throw sqle;
        }finally {
          st.close();
          rs.close();
        }
    }

    public Connection getConnection(){
      return connection;
    }
}