package com.fladsrud.databasecreator.menu.gui;

import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreeSelectionModel;
import java.awt.*;
import javax.swing.*;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeModelListener;
import javax.swing.event.TreeModelEvent;
import javax.swing.tree.DefaultTreeModel;
import java.awt.event.*;
import com.fladsrud.databasecreator.menu.*;

public class Help extends JDialog implements com.fladsrud.databasecreator.Constants{
  private BorderLayout borderLayout1 = new BorderLayout();
  private JPanel pnlHeader = new JPanel();
  private JScrollPane scrHelpTree;
  private JScrollPane scrHelpInformation = new JScrollPane();
  private JEditorPane edtHelpText = new JEditorPane();
  private JPanel pnlButtons = new JPanel();
  private FlowLayout flowLayout1 = new FlowLayout();
  private JButton btnClose = new JButton();
  private HelpHeader mainhelpheader[];
  private HelpText helptext[];
  private FlowLayout flowLayout2 = new FlowLayout();
  private JButton jButton1 = new JButton();

  public Help(JFrame parent, String title, boolean modale){
    super(parent, title, modale);
    try {
      init();
      jbInit();
  //  this.setSize(587, 600);
    this.setSize(597, 600);

    com.fladsrud.gui.WindowLocation.centerWindow(this);
       this.setResizable(false);
    this.setVisible(true);
    }
    catch(Exception e) {
      e.printStackTrace();
    }

  }

private void init(){
    helptext = new HelpText[10];
    helptext[0]= new HelpText(0, "<h1>Requirements</h1><li>java 1.4.0_03-b04 or higher</li><li>Windows 95/ME/2000/XP (might work on other Windows platforms also)</li>");
    helptext[1]= new HelpText(1, "<h1>Open existing database</h1>Select the folder where the HSQLDB database is located. Then in the field Database name you type the name of the database.");
    helptext[2]= new HelpText(2, "<h1>Create new database</h1>Select the folder where you want to place the new database. Then in the field Database name you type the name you want on your database.");
    helptext[3]= new HelpText(3, "<h1>Create tables</h1>In the first textarea you may place you script to create a table. Below is an example of creating tables.<br><br>"+
    "CREATE CACHED TABLE Book ( Bookindex INTEGER, Name VARCHAR(50), Authorindex INTEGER, "+
    "PRIMARY KEY(Bookindex));<br>"+
    "CREATE CACHED TABLE Author ( Authorindex INTEGER, Name VARCHAR(20), Address VARCHAR(40),"+
            "PRIMARY KEY(Authorindex));");
    helptext[4]= new HelpText(4, "<h1>Usage - SELECT</h1>To view the content of a table you may execute 1-n SELECT statements from 1-n tables separated by ';'.<br><h2>Example</h2>"+
    "SELECT * FROM Book WHERE Bookindex = 1;<br>"+
    "SELECT Name, Address FROM Author;");
    helptext[5]= new HelpText(5, "<h1>Usage - INSERT</h1>To insert data into a table you may execute 1-n INSERT statements to 1-n tables separated by ';'.<br><h2>Example</h2>"+
    "INSERT INTO Book(Bookindex, Name, Authorindex) VALUES(1, 'The Call Of The Mild', 1);<br>"+
    "INSERT INTO Author(Authorindex, Name, Address) VALUES(1, 'Jack London', 'N/A');"+
    "");
    helptext[6]= new HelpText(6, "<h1>Usage - UPDATE</h1>To update the data of a table you may execute 1-n UPDATE statements to 1-n tables separated by ';'.<br><h2>Example</h2>"+
    "UPDATE Book SET Name='The Call Of The Wild' WHERE Bookindex=1;"+
    "");
    helptext[7]= new HelpText(7, "<h1>Usage - ALTER TABLE</h1>To alter a table, you 1-n ALTER TABLE statements to 1-n tables separated by ';'.<br><h2>Example</h2>"+
  //  "ALTER TABLE Book ADD NumberOfPages INTEGER;"+
    "");
    helptext[8]= new HelpText(8, "<h1>Usage - DROP TABLE</h1>To delete a table you may execute 1-n DROP TABLE <table> statements to 1-n tables separated by ';'.<br><h2>Example</h2>"+
    "DROP TABLE Book;<br>"+
    "DROP TABLE Author;"+
    "");
    helptext[9]= new HelpText(9, "<h1>About</h1>Database Creator is developed by<br>Tom Fladsrud<br>Email tom@fladsrud.com<br><br><center>Copyright(c)2007 Tom Fladsrud</center>");

    HelpHeader sub2[] = new HelpHeader[5];
    sub2[0] = new HelpHeader(0, "SELECT", null, helptext[4]);
    sub2[1] = new HelpHeader(1, "INSERT", null, helptext[5]);
    sub2[2] = new HelpHeader(2, "UPDATE", null, helptext[6]);
    sub2[3] = new HelpHeader(3, "ALTER", null, helptext[7]);
    sub2[4] = new HelpHeader(4, "DROP", null, helptext[8]);

    HelpHeader sub1[] = new HelpHeader[4];
    sub1[0] = new HelpHeader(0, "Open existing database", null, helptext[1]);
    sub1[1] = new HelpHeader(1, "Create new database", null, helptext[2]);
    sub1[2] = new HelpHeader(2, "Create tables", null, helptext[3]);
    sub1[3] = new HelpHeader(3, "Queryes", sub2, null);

    mainhelpheader = new HelpHeader[3];
    mainhelpheader[0] = new HelpHeader(0, "Requirements", null,helptext[0]);
    mainhelpheader[1] = new HelpHeader(1, "Usage", sub1, null);
    mainhelpheader[2] = new HelpHeader(2, "About", null, helptext[9]);





}

  public void createSubjects(DefaultMutableTreeNode subjectnode, HelpHeader header){
      HelpHeader subs[] = header.getSubHeader();
      if (subs != null){
        for(int s = 0; s<subs.length; s++){ //Create the top nodes
          DefaultMutableTreeNode sub = new DefaultMutableTreeNode(subs[s]);
          subjectnode.add(sub);
          createSubjects(sub, subs[s]);
        }
      }
  }

  public JTree createThree(){
    DefaultMutableTreeNode top = new DefaultMutableTreeNode("Help Database Creator");
    //Add the nodes here
    int toplength = mainhelpheader.length;
    DefaultMutableTreeNode subjectnodes[] = new DefaultMutableTreeNode[toplength];

    for(int s = 0; s<toplength; s++){ //Create the top nodes
      subjectnodes[s] = new DefaultMutableTreeNode(mainhelpheader[s]);//create a node
      createSubjects(subjectnodes[s], mainhelpheader[s]);
      top.add(subjectnodes[s]);//Add the nodes
    }



    DefaultTreeModel treeModel = new DefaultTreeModel(top);

    treeModel.addTreeModelListener(new TreeModelListener(){
        public void treeNodesChanged(TreeModelEvent e) {
        }
        public void treeNodesInserted(TreeModelEvent e) {
        }
        public void treeNodesRemoved(TreeModelEvent e) {
        }
        public void treeStructureChanged(TreeModelEvent e) {
          System.out.println("Changes");
        }
    });

    final JTree tree = new JTree(treeModel);
    tree.setEditable(true);
    tree.getSelectionModel().setSelectionMode
            (TreeSelectionModel.SINGLE_TREE_SELECTION);
    tree.setShowsRootHandles(true);


    tree.addTreeSelectionListener(new TreeSelectionListener(){
      public void valueChanged(TreeSelectionEvent e){
        DefaultMutableTreeNode node = (DefaultMutableTreeNode) tree.getLastSelectedPathComponent();
        if(node == null)return;

        Object nodeInfo = node.getUserObject();

        if(node.isLeaf()){
          HelpHeader helpheader = (HelpHeader) nodeInfo;

            //System.out.println(""+helpheader);
          edtHelpText.setText(helpheader.getHelpText().getHelptext());

        }
      }
    });
    return tree;
  }
  private void jbInit() throws Exception {
    this.getContentPane().setLayout(borderLayout1);
    scrHelpTree = new JScrollPane(createThree());
    scrHelpTree.setPreferredSize(new Dimension(150, 4));
    pnlHeader.setLayout(flowLayout2);
    edtHelpText.setContentType("text/html");
    flowLayout2.setAlignment(FlowLayout.LEFT);
    flowLayout2.setHgap(0);
    flowLayout2.setVgap(0);
    jButton1.setText("jButton1");
    scrHelpInformation.getViewport().add(edtHelpText, null);
    pnlHeader.setPreferredSize(new Dimension(10, 57));
    pnlButtons.setPreferredSize(new Dimension(10, 40));
    pnlButtons.setLayout(flowLayout1);
    flowLayout1.setAlignment(FlowLayout.RIGHT);
    btnClose.setText("Close");
    btnClose.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnClose_actionPerformed(e);
      }
    });
    this.getContentPane().add(pnlHeader, BorderLayout.NORTH);
//    pnlHeader.add(new JLabel(new ImageIcon(headerpath)), null);
    pnlHeader.add(new JLabel(new ImageIcon(headerlogopath)), null);
    for (int i=0; i< 20; i++){
    pnlHeader.add(new JLabel(new ImageIcon(headerrightpath)), null);
}

    this.getContentPane().add(scrHelpTree,  BorderLayout.WEST);
    this.getContentPane().add(scrHelpInformation, BorderLayout.CENTER);
    this.getContentPane().add(pnlButtons,  BorderLayout.SOUTH);
    pnlButtons.add(btnClose, null);
  }

  void btnClose_actionPerformed(ActionEvent e) {
  this.dispose();
  }


}